Building a small memory footprint library
Prev | Chapter 27. Building Berkeley DB for UNIX/POSIX | Next

## Building a small memory footprint library

There are a set of configuration options to assist you in building a small memory footprint library. These configuration options turn off specific functionality in the Berkeley DB library, reducing the code size. These configuration options include:

  To build Berkeley DB without support for cryptography, enter --disable-cryptography as an argument to configure.
  To build Berkeley DB without support for the Hash access method, enter --disable-hash as an argument to configure.
  To build Berkeley DB without support for the Queue access method, enter --disable-queue as an argument to configure.
  To build Berkeley DB without support for the database environment replication, enter --disable-replication as an argument to configure.
  To build Berkeley DB without support for the statistics interfaces, enter --disable-statistics as an argument to configure.
  To build Berkeley DB without support for database verification, enter --disable-verify as an argument to configure.
  Equivalent to individually specifying --disable-cryptography, --disable-hash, --disable-queue, --disable-replication, --disable-statistics and --disable-verify. In addition, when compiling building with the GNU gcc compiler, the --enable-smallbuild option uses the -Os compiler build flag instead of the default -O3.

The following configuration options will increase the size of the Berkeley DB library dramatically and are only useful when debugging applications:

--enable-debug
  Build Berkeley DB with symbols for debugging.
--enable-debug_rop
  Build Berkeley DB with read-operation logging.
--enable-debug_wop
  Build Berkeley DB with write-operation logging.
--enable-diagnostic
  Build Berkeley DB with run-time debugging checks.

In addition, static libraries are usually smaller than shared libraries. By default Berkeley DB will build both shared and static libraries. To build only a static library, configure Berkeley DB with the Configuring Berkeley DB option.

The size of the Berkeley DB library varies depending on the compiler, machine architecture, and configuration options. As an estimate, production Berkeley DB libraries built with GNU gcc version 3.X compilers have footprints in the range of 400KB to 1.2MB on 32-bit x86 architectures, and in the range of 500KB to 1.4MB on 64-bit x86 architectures.

For assistance in further reducing the size of the Berkeley DB library, or in building small memory footprint libraries on other systems, please contact Berkeley DB support.

Prev | Up | Next
Configuring Berkeley DB | Home | Changing compile or load options